<?php
// +-----------------------------------------------------------------------+
// | Mod Name : CopyExcel                                                  |
// | Mod Version : 1.1                                                     |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// | Mod description :                                                     |
// | Permet la copie de la vignette dans un rpertoire                     |
// | pour pouvoir la rcuprer par Excel                                   |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

class CopyExcel {
  var $plugin_name, $plugin_path, $plugin_url;
  var $my_config;

  function CopyExcel($plugin_name, $plugin_path, $plugin_url) {
    // Args
    $this->plugin_name = $plugin_name;
    $this->plugin_path = $plugin_path;
    $this->plugin_url = $plugin_url;
    // handler
    $this->initialize_event_handler($plugin_name, $plugin_path, $plugin_url);
  }

  function initialize_event_handler() {
    global $user;
    $this->load_config(); // Chargement de la configuration
    $this->load_lang(); // Chargement des langues
  
    add_event_handler('add_images', array(&$this, 'CopieImages'));
    
    // Ajouter un trigger dans le fichier admin/include/functions.php
    // Au début de la fonction delete_elements
    add_event_handler('begin_delete_elements', array(&$this, 'SupprimeImages'));
    
    if (is_admin()) {
      // ---- Administration
      add_event_handler('get_admin_plugin_menu_links', array(&$this, 'plugin_admin_menu')); // Menu d'administration
    }    
  }

  function load_config() {
    $x = @file_get_contents( $this->plugin_path.'data.dat' );
    if ($x!==false) {
      $c = unserialize($x);
      // do some more tests here
      $this->my_config = $c;
    }

    if (!isset($this->my_config)) {
      $this->my_config['repertoire'] = false;
      $this->save_config();
    }
  }

  // Affichage du lien dans la barre
  // menu administrateur
  function plugin_admin_menu($menu) {
    array_push($menu,
      array(
        'NAME' => 'Copy Excel',
        'URL' => get_admin_plugin_menu_link($this->plugin_path.'admin/CpExcelAdmin.php')
      )
    );
    return $menu;
  }
  
  // Sauvegarde de la configuration
  function save_config() {
    $file = fopen( $this->plugin_path.'data.dat', 'w' );
    fwrite($file, serialize($this->my_config) );
    fclose($file);
  }
  
  // Chargement des fichiers langues
  function load_lang() {
    global $lang;
    include(get_language_filepath('plugin.lang.php', $this->plugin_path) );
  }
    
  // Copie les fichiers dans le rpertoire dfinit dans le fichier
  function CopieImages($inserts) {
  	global $conf;

  	foreach ($inserts as $cle => $file) {  	  
  	  $dir = dirname($file['path']);

  	  if(file_exists($this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$file['file'])) {
        unlink($this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$file['file']);
      }

      // Copie de la vignette
      copy($dir.'/thumbnail/'.$conf['prefix_thumbnail'].$file['file'], $this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$file['file']);  	  
  	}	
  }

  // Supprime les fichiers non prsent dans la base
  // $ids -> identifiant des images  supprimer
  function SupprimeImages($ids) {
  	global $conf;
   	
    $query = '
      SELECT file FROM '.IMAGES_TABLE.'
      WHERE id IN(
        '.wordwrap(implode(', ', $ids), 80, "\n").')
      ;';
    $result = pwg_query($query);
    
    while($row = mysql_fetch_array ($result)) {
      if(file_exists($this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$row['file'])) {
        unlink($this->plugin_path.$this->my_config['repertoire'].'/'.$conf['prefix_thumbnail'].$row['file']);
      }
    }
  }
}
?>